
import { stringify } from 'qs';
import {
  queryCampusList,
  queryTerminalsList,
  queryCampusAmount,
  queryTotalList,

} from '../services/accounts';

export default {
  namespace: 'accounts',

  state: {
    list: [],
    pageNo: 1,
    pageSize: 15,
    totalSize: 0,
    campusAmount: 0,
    currentItem: {},
  },

  effects: {
    *fetchCampusList({ payload }, { call, put }) {
      const response = yield call(queryCampusList, payload);
      if (response.success) {
        yield put({
          type: 'querySuccess',
          payload: {
            list: response.data.list || [],
            pageSize: response.data.pageSize,
            totalSize: response.data.totalSize,
            pageNo: response.data.pageNo,
          },
        });
      }
    },
    *fetchCampusExcel({ payload }, { call }) {
      window.open('/api/stmt/campus/export');
    },
    *fetchTerminalsList({ payload }, { call, put }) {
      const response = yield call(queryTerminalsList, payload);
      if (response.success) {
        yield put({
          type: 'querySuccess',
          payload: {
            list: response.data.list || [],
            pageSize: response.data.pageSize,
            totalSize: response.data.totalSize,
            pageNo: response.data.pageNo,
          },
        });
      }
    },
    *fetchTerminalsExcel({ payload }, { call }) {
      window.open(`/api/stmt/campus/export?${stringify(payload)}`);
    },

    *fetchCampusAmount({ payload }, { call, put }) {
      const response = yield call(queryCampusAmount, payload);
      if (response.success) {
        yield put({
          type: 'querySuccess',
          payload: {
            campusAmount: response.data,
          },
        });
      }
    },
    *fetchTotalList({ payload }, { call, put }) {
      const response = yield call(queryTotalList, payload);
      if (response.success) {
        yield put({
          type: 'querySuccess',
          payload: {
            list: response.data.list || [],
            pageSize: response.data.pageSize,
            totalSize: response.data.totalSize,
            pageNo: response.data.pageNo,
          },
        });
      }
    },
  },

  reducers: {
    querySuccess(state, action) {
      return {
        ...state,
        ...action.payload,
      };
    },
  },

};
